//ֿ12864Һ߻ʾ
#include<reg52.h>
#define uchar unsigned char
#define uint unsigned int
#define RSsp_On 0x3f//ʾ
#define RSsp_Off 0x3e//ʾ
#define Col_Add 0x40//еַ
#define Page_Add 0xb8//ҳַ
#define Start_Line 0xc0//ʼҳ	
sbit cs1=P1^3; //Master chip EN
sbit cs2=P1^4; //Slave chip EN
sbit en=P1^2; // mode EN single
sbit rs=P1^0; //Data or Instrument Select
sbit rw=P1^1; //Write or Read
sbit rst=P1^5; //Lcm reset


/***********************ʱӳ***********************/
void delayms(int k)
{
   int i,j;
for(i=k;i>0;i--)
for(j=1000;j>0;j--);
}

/*************дָ************************/
void write_com(uchar com)
{
rs=0;
rw=0;
P0=com;
delayms(1);
en=1;
delayms(1);
en=0;
}

/*************д************************/
void write_dat(uchar dat)
{
rs=1;
rw=0;
P0=dat;
delayms(1);
en=1;
delayms(1);
en=0;
}


/******************************/
void frame()
{
 uchar i;
 cs1=1;cs2=1;
 write_com(Page_Add+0);//ҳ׵ַ
 write_com(Col_Add+0);//׵ַ
 for(i=0;i<64;i++)
   write_dat(0x01);//ϲһߣǵַλ

 write_com(Page_Add+7);//ҳ׵ַ
 write_com(Col_Add+0);//׵ַ
 for(i=0;i<64;i++)
   write_dat(0x80);//²һߣǵַλ
//еַǵλϣλ
/////
   for(i=0;i<8;i++)
     {
	   cs1=1;cs2=1;
	   write_com(Page_Add+i);
	   write_com(Col_Add+63);
	   write_dat(0xff);

	    cs1=1;cs2=1;
	   write_com(Page_Add+i);
	   write_com(Col_Add+0);
	   write_dat(0xff);

	 }
}

/**********************************/
void clear()
{
uchar j,k;
cs1=1;cs2=1;
write_com(Page_Add+0);
write_com(Col_Add+0);
  for(j=0;j<8;j++)
	{
	  write_com(Page_Add+j);
	   for(k=0;k<64;k++)
	    write_dat(0x00);
	}

}


void init()
{
 rst=0;
 delayms(100);
 rst=1;
 delayms(100);
 cs1=1;
 cs2=1;
 delayms(100);
 write_com(RSsp_Off);
 write_com(Page_Add+0);
  write_com(Col_Add+0);
 write_com(Start_Line+0);
  write_com(RSsp_On);
}

/**********************************/
void Dr_H_line()
{
 uchar i,j;
 cs1=1;cs2=1;
 write_com(RSsp_On);
 write_com(Page_Add+0);
 write_com(Col_Add+0);
 write_com(Start_Line+0);
  for(i=0;i<8;i++)
    {
	 write_com(Page_Add+i);
	 write_com(Col_Add+0);
	    for(j=0;j<64;j++)
		 write_dat(0x55);
	}
}

/*******************************/
void Dr_V_line()
{
 uchar i,j;
//cs1=1;cs2=1;
 write_com(RSsp_On);
 write_com(Page_Add+0);
 write_com(Col_Add+0);
 write_com(Start_Line+0);
  for(i=0;i<8;i++)
    {
	 write_com(Page_Add+i);
	 write_com(Col_Add+0);
	    for(j=0;j<32;j++)
		{
		 write_dat(0x00);
		  write_dat(0xff);
//еַԶ1
		 }
	}
}

void main()
{
 init();
 clear();
 frame();
 Dr_H_line();
 Dr_V_line();
 while(1);
}
