/*ݣT0ⲿT1ʱ1S1Sⲿ
1602ҺʾƵʣλʱ񶯵Ĵ*/
#include<reg52.h>
#include<stdio.h>
#include<intrins.h>
#define uchar  unsigned char

#define CHECK_BUSY


sbit RS = P1^0;   //˿ 
sbit RW = P1^1;
sbit EN = P1^2;

bit OVERFLOWFLAG;
bit TIMERFLAG;

void DelayMs(uchar t)
{
int x,y;
for (x=t;x>0;x--)
  for(y=110;y>0;y--);
 
}  

/*æ*/
 bit LCD_Check_Busy(void) 
 { 
#ifdef CHECK_BUSY
 P0= 0xFF; 
 RS=0; 
 RW=1; 
 EN=0; 
 _nop_(); 
 EN=1;
 return (bit)(P0 & 0x80);
#else
 return 0;
#endif
 }
/*д*/
 void write_Com(uchar com) 
 {  
 while(LCD_Check_Busy()); //æȴ
 RS=0; 
 RW=0; 
 EN=1; 
 P0= com; 
 _nop_(); 
 EN=0;
 }
/*дݺ*/
 void write_dat(uchar dat) 
 { 
 while(LCD_Check_Busy()); //æȴ
 RS=1; 
 RW=0; 
 EN=1; 
 P0= dat; 
 _nop_();
 EN=0;
 }

/**/
 void LCD_Clear(void) 
 { 
 write_Com(0x01); 
 DelayMs(5);
 }

/*дַ*/
void LCD_Write_Char(uchar x,uchar y,uchar dat) 
 {     
 if (y == 0) 
 	{     
 	write_Com(0x80 + x);     
 	}    
 else 
 	{     
 	write_Com(0xC0 + x);     
 	}        
 write_dat( dat);  
 }

/*дַ*/
 void LCD_Write_String(uchar x,uchar y,uchar *s) 
 {     
       
 while (*s) 
 	{     
 LCD_Write_Char(x,y,*s);     
 s ++;  x++;   
 	}
 }

/*ʼ*/
 void LCD_Init(void) 
 {  
   write_Com(0x38);
   write_Com(0x06); /*ʾƶ*/ 
   DelayMs(5); 
   write_Com(0x0C); /*ʾ*/
   write_Com(0x01);  /*ʾ*/ 
 }
   



/*ʱ0ʼӳ,ڼ*/
void Init_Timer0(void)
{
 TMOD |= 0x01 | 0x04;//ʹģʽ116λʹ"|"ſʹöʱʱӰ		     
 TH0=0x00; //ֵ
 TL0=0x00;         
 EA=1; //жϴ
 ET0=1; //ʱжϴ
 TR0=1;//ʱش
}
/*ʱ1ʼӳ,ڶʱ*/
void Init_Timer1(void)
{
 TMOD |= 0x10;	  //ʹģʽ116λʱʹ"|"ſʹöʱʱӰ 
 TH1=(65536-10000)/256;	      //ֵʹöʱֵ0ʼһֱ65535
 TL1=(65536-10000)%256;
 EA=1;            //жϴ
 ET1=1;           //ʱжϴ
 TR1=1;           //ʱش
}


main()
{
 unsigned  long int a;
 char temp[16]; //ַʾ
 Init_Timer0(); //ʼʱ0
 Init_Timer1(); //ʼʱ1
 LCD_Init();//ʼҺ
 DelayMs(10); //ʱȶȥ
 LCD_Clear();//
 LCD_Write_String(0,0,"HKY Hehuasheng");//дһϢѭвٸĴϢwhile֮ǰд
 while(1)
 {
  if(OVERFLOWFLAG)//־ƵʹߣʾϢ
    {
	 OVERFLOWFLAG=0;//־
     LCD_Write_String(0,1,"overflow >655KHz");
	}
  if(TIMERFLAG)      //ʱ100msݴ
    {
	 a=TL0+TH0*256;//ȡֵ
	 a=a*10; //ʵֵ
     sprintf(temp,"FREQ:%08.0f Hz",(float)a);
     LCD_Write_String(0,1,temp);//ʾҺڶ
	 TR0=1; //2ʱ
	 TR1=1;
	 TH0=0; //ֵ֤Ϊ0
	 TL0=0;
	 TIMERFLAG=0;//ʱ־
	 
	}
  }
}

/*ʱ0жӳ*/
void Timer0_isr(void) interrupt 1
{
 TH0=00;	      //¸ֵ
 TL0=00; 

 OVERFLOWFLAG=1;  //־

}
/*ʱ1жӳ*/
void Timer1_isr(void) interrupt 3
{
 static uchar i;
 TH1=(65536-10000)/256;		 //¸ֵ10ms
 TL1=(65536-10000)%256;

 i++;
 if(i==10) //100ms ʱ䵥λó100ms x101sΪƵ Hz 
   {
   i=0;
   TR0=0;  //2ʱر
   TR1=0;
   TIMERFLAG=1;  //־λ
   TH1=(65536-10000)/256;	 //¸ֵ
   TL1=(65536-10000)%256;
   }
}
