#include<reg52.h> 
#include<stdio.h>
#include<intrins.h>
#define uchar  	unsigned char
#define uint  	unsigned int
#define CHECK_BUSY
#define KeyPort P1
sbit RS = P2^4;   //˿ 
sbit RW = P2^5;
sbit EN = P2^6;
unsigned char code password[8]={1,2,3,4,5,6,7,8};//ԸĴ

void delayms(int t)
{
  int x,y;
  for(x=t;x>0;x--)
    for(y=110;y>0;y--); 
  
}

/*æ*/
 bit LCD_Check_Busy(void) 
 { 
#ifdef CHECK_BUSY
 P0= 0xFF; 
 RS=0; 
 RW=1; 
 EN=0; 
 _nop_(); 
 EN=1;
 return (bit)(P0 & 0x80);
#else
 return 0;
#endif
 }
/*д*/
 void write_com(uchar com) 
 {  
 while(LCD_Check_Busy()); //æȴ
 RS=0; 
 RW=0; 
 EN=1; 
 P0= com; 
 _nop_(); 
 EN=0;
 }
/*дݺ*/
 void write_dat(uchar dat) 
 { 
 while(LCD_Check_Busy()); //æȴ
 RS=1; 
 RW=0; 
 EN=1; 
 P0= dat; 
 _nop_();
 EN=0;
 }

/**/
 void LCD_Clear(void) 
 { 
 write_com(0x01); 
 delayms(5);
 }
 /*дַ*/
void write_char(uchar x,uchar y,uchar dat) 
 {     
 if (y == 0) 
 	{     
 	write_com(0x80 + x);     
 	}    
 else 
 	{     
 	write_com(0xC0 + x);     
 	}        
 write_dat( dat);  
 }

/*дַ*/
 void write_string(uchar x,uchar y,uchar *s) 
 {     
       
 while (*s) 
 	{     
 write_char(x,y,*s);     
 s ++;  x++;   
 	}
 }

/*------------------------------------------------
              ʼ
------------------------------------------------*/
 void LCD_Init(void) 
 {
   write_com(0x38);    /*ʾģʽ*/ 
   delayms(5);
   write_com(0x06);    /*ʾƶ*/ 
   delayms(5); 
   write_com(0x0C);    /*ʾ*/
   write_com(0x01);    /*ʾ*/ 
 }
   

/*------------------------------------------------
ɨ躯ɨֵ
------------------------------------------------*/
unsigned char KeyScan(void)  //ɨ躯ʹзתɨ跨
{
 unsigned char cord_h,cord_l;//ֵм
 KeyPort=0x0f;            //ȫΪ0
 cord_h=KeyPort&0x0f;     //ֵ
 if(cord_h!=0x0f)    //ȼް
 {
  delayms(10);        //ȥ
  if((KeyPort&0x0f)!=0x0f)
  {
    cord_h=KeyPort&0x0f;  //ֵ
    KeyPort=cord_h|0xf0;  //ǰֵ
    cord_l=KeyPort&0xf0;  //ֵ

    while((KeyPort&0xf0)!=0xf0);//ȴɿ

    return(cord_h+cord_l);//ֵ
   }
  }return(0xff);     //ظֵ
}
/*------------------------------------------------
ֵɨֵ
------------------------------------------------*/
unsigned char KeyPro(void)
{
 switch(KeyScan())
 {
  case 0x7e:return 0;break;//0 ӦļʾӦֵ
  case 0x7d:return 1;break;//1
  case 0x7b:return 2;break;//2
  case 0x77:return 3;break;//3
  case 0xbe:return 4;break;//4
  case 0xbd:return 5;break;//5
  case 0xbb:return 6;break;//6
  case 0xb7:return 7;break;//7
  case 0xde:return 8;break;//8
  case 0xdd:return 9;break;//9
  case 0xdb:return 10;break;//a
  case 0xd7:return 11;break;//b
  case 0xee:return 12;break;//c
  case 0xed:return 13;break;//d
  case 0xeb:return 14;break;//e
  case 0xe7:return 15;break;//f
  default:return 0xff;break;
 }
}

main()
{
 unsigned char num,i,j;                  
 unsigned char passwordtemp[16];        //16
 unsigned char inputtimes;              //
 unsigned char passwordlength,PLEN;     //볤ȣʵ볤
 bit Flag;
 
 PLEN=sizeof(password)/sizeof(password[0]);//ڼʵ볤
 
 LCD_Init();         //ʼҺ
 delayms(10);        //ʱȶȥ
 LCD_Clear();        //
 write_string(0,0,"  Welcome! ");    //дһϢѭвٸĴϢwhile֮ǰд
 write_string(0,1,"Input password!");    //дڶϢʾ
while (1)         //ѭ
  {


 num=KeyPro();  //ɨ
 if(num!=0xff)  //ɨǰЧֵд
   { 
    if(i==0)    //ǵһַʱҪѸգۿ
	 write_string(0,1,"                ");//
	if(i<16)
	  {
       passwordtemp[i]=num;
       write_char(i,1,'*');//"*"
	   }
	i++;   //ֵۼ
	if((15==num)|| (i==16))//밴ֵ15뵽ֵ16ʾҪбȶ
	  {
      passwordlength=i-1;  //볤
	  i=0;  //λ
	  if(passwordlength==PLEN)//Ƚϣֱ
	    {
	     Flag=1;//ȰѱȽλ1
	     for(j=0;j<PLEN;j++)//ѭȽ8ֵһ FlagֵΪ0
	        Flag=Flag&&(passwordtemp[j]==password[j]);//Ƚֵ
         }
      if(Flag)//Ƚȫͬ־λ1
	   {
	   write_string(0,1,"                ");//
       write_string(0,1,"Right Open!>>>>");//ȷʾϢ
        inputtimes=0;//ȷ㣬¼
        Flag=0;      //ȷ־
		}
	  else 
	    {
		write_string(0,1,"                ");//
		write_string(0,1,"Wrong! Retry!");//ʾ
		inputtimes++;//ۼ
		if(inputtimes==3)
		  {
		  write_string(0,1,"                ");//
		  write_string(0,1,"Wrong 3 times!");//ʾ
		   while(1);//ֹͣλãԴ룬ʵʵҪȵһʱٴ롣
		  }
		}

	  }
    }	
  }
}

