#include<reg52.h>
#include<math.h>

#define uchar unsigned char
#define uint  unsigned int
#define Lcd_DatBus  P0

sbit rs=P1^0;
sbit rw=P1^1;
sbit en=P1^2;
//sbit PSB=P1^3;


uchar table[]={"Ƕú!"};

uchar GDRAM_hbit=0;
uchar GDRAM_lbit=0;

 
/****************************************************************
  ƣdelay1ms
  ܣʱԼ1ms
  uchar n
ֵ
*****************************************************************/
void delayms(uchar z)
{ 
	uchar x,y;
  	for(x=0;x<z;x++)
     	for(y=0;y<110;y++);
}



/*********************************************************
  : write_com
  ܣҺд
  com--
ֵ
*********************************************************/
void Write_com(uchar com)
{
    uchar temp=0;   
	rs=0;
 	rw=1;
 	do //æ
    {
    	en=1;
    	delayms(1);
    	temp=P0;
    	en=0;
   	}
   	while(temp&0x80);
	rw=0;
 	P0=com;
 	delayms(1);
 	en=1;
 	delayms(1);
 	en=0;      
}


/********************************************************
  ƣwrite_dat
  ܣҺд
  dat--ʾ
ֵ
*********************************************************/
void Write_data(uchar dat)
{  
   	uchar temp=0;
   	rs=0;
   	rw=1;
   	do    //æ
   	{
      	en=1;
   		delayms(1);
      	temp=P0;
      	en=0;
   	}
   while(temp&0x80);

   rs=1;
   rw=0;
   P0=dat;
   en=1;
   delayms(1);
   en=0;
}



/**********ȡǰַLCDʾ**********/

uchar Read_data()
{
	uchar shuju;
	P0=0xff;
	rs=1; // D/I=1
	rw=1; // R/W=1.ȡ
	delayms(10);
	en=1;
	delayms(100);
	shuju=P0;    //ȡǰʾ
	en=0;
	return(shuju);   
}






/*******************************************
ƣDraw_TX
    ܣʾһ16*16Сͼ
    Yaddr--Yַ
          Xaddr--Xַ
          dp--ָͼݴŵַָ
ֵ  
********************************************/
void Draw_TX(uchar Yaddr,uchar Xaddr,const uchar * p) 
{
    uchar j;
    uchar k=0;
 
    Write_com(0x01);  //,ֻDDRAM
    Write_com(0x34);  //ʹչָرջͼʾ
    for(j=0;j<16;j++)
    {
        Write_com(Yaddr++);   //Yַ
    	Write_com(Xaddr); //Xַ
    	Write_data(p[k++]);  
    	Write_data(p[k++]);
    }
    Write_com(0x36);  //򿪻ͼʾ
    Write_com(0x30);  //صָģʽ
}

/**************************************************************
  ƣclear_DGRAM
  ܣҺGDRAMе
  
ֵ
**************************************************************/
void clear_GDRAM(void)
{
   	uchar i,j,k;

   	Write_com(0x34);  //չָ
	i=0x80;
	for(j=0;j<32;j++)
    {  
    	Write_com(i++);
    	Write_com(0x80);
    	for(k=0;k<16;k++)
      	{ 
			Write_data(0x00); 
		}
  	}

   	i=0x80;
   	for(j=0;j<32;j++)
    {
     	Write_com(i++);
   		Write_com(0x88);
   		for(k=0;k<16;k++)
      	{ 
			Write_data(0x00); 
		}
   	}
   	Write_com(0x30); //صָ	
}   


/****************************
㺯:Write_Point()
xʾУyʾΪС
******************************/


void Write_Point(uchar x,uchar y,uchar flag)
{
    uchar x_dyte,x_byte; //еַֽλֽе1λ 
	uchar y_dyte,y_byte; //Ϊ(ȡֵΪ01)еַ(ȡֵΪ0~31)
	Write_com(0x36); //ͼģʽ

  /***X,Y껥ͨX,Y***/

  	x_dyte=y/16; //16ֽеһ
  	x_byte=y&0x0f; //ڸֽеһλ
  	y_dyte=x/32; //0Ϊϰ1Ϊ°
  	y_byte=x&0x1f; //0~31еһ
  	Write_com(0x80+y_byte); //趨еַ(y)
  	Write_com(0x80+x_dyte+8*y_dyte); //趨еַ(x)ͨ8*y_Dyteѡ

    Read_data();
	GDRAM_hbit=Read_data();//ȡǰʾ8λ
	GDRAM_lbit=Read_data();//ȡǰʾ8λ
  	delayms(5);


  	if(flag==1)
	{ 
		Write_com(0x80+y_byte); //趨еַ(y)
  		Write_com(0x80+x_dyte+8*y_dyte); //趨еַ(x)ͨ8*y_Dyteѡ
		delayms(5);
  		
		if(x_byte<8) //жڸ8λڵ8λ
		{
			Write_data(GDRAM_hbit|(0X01<<(7-x_byte)));   //ʾGDRAM8λ
			Write_data(GDRAM_lbit); //ʾGDRAM8λ 
		}
    	else
		{
    		Write_data(GDRAM_hbit);
			Write_data(GDRAM_lbit|(0x01<<(15-x_byte)));
		}
    }
	else
	{
		Write_data((0x00)); //GDRAM8λ
		Write_data((0x00)); //GDRAM8λ
	}
}      




/*********************************************************** 
ƣWrite_Line(unsigned char x0,unsigned char y0,unsigned char x1,unsigned char y1,unsigned char colour) 
ܣָλϻߡ 
ڲx0  ָеλ 
           y0   ָеλ 
           x1   ָյеλ 
           y1   ָյеλ 
          flag  ʾɫ(ںڰɫLCMΪ0ʱΪ1ʱʾ) 
/**********************************************************/ 
void Write_Line(uchar x0,uchar y0,uchar x1,uchar y1,uchar flag) 
{ 
    int temp; 
    int dx,dy; //㵽յĺᡢֵ 
    int s1,s2,i,j; 
    int Dx,Dy,k; 

    dx=x1-x0; 
    if(dx>=0) //Xķӵ 
    	s1=1; 
    else   //Xķǽ͵ 
        s1=-1; 
		     
    dy=y1-y0; //жYķӻǽ 
    if(dy>=0) 
        s2=1; 
    else 
        s2=-1; 
   
    Dx=abs(x1-x0); //ᡢݱ־ֵľֵ 
    Dy=abs(y1-y0); 
    if(Dy>Dx)                               
    { //45ȽΪֽߣYstatus=1,Xstatus=0  
        temp=Dx; 
        Dx=Dy; 
        Dy=temp; 
    	j=1; 
    }  
    else 
        j=0; 


/*********Bresenham㷨ֱ********/  
    k=2*Dy-Dx; //1ж¸λ 
    for(i=0;i<Dx;i++) 
    {  
        Write_Point(x0,y0,flag); //  
        if(k>=0)                                
        {  
            if(j==1) //ڿYxֵ1 
            x0+=s1;  
            else   //ڿXyֵ1                
            y0+=s2;  
           	k-=2*Dx; //ж¸λ  
        }  
        if(j==1) 
            y0+=s2;  
        else        
            x0+=s1;  
        	k+=2*Dy;  
    }  
} 

 


/**************************************************************************** 
ƣplotC(int x,int y,int xc,int yc,unsigned char colour) 
ܣ˷ֵ㻭Բ 
ڲx ָеλ 
           y ָеλ 
          color ʾɫ(ںڰɫLCMΪ0ʱΪ1ʱʾ) 
****************************************************************************/ 
void plotC(uint x,uint y,uint xc,uint yc,uchar colour) 
{ 
    Write_Point(xc+x,yc+y,colour); 
    Write_Point(xc+x,yc-y,colour); 
    Write_Point(xc-x,yc+y,colour); 
    Write_Point(xc-x,yc-y,colour); 
    Write_Point(xc+y,yc+x,colour); 
    Write_Point(xc+y,yc-x,colour); 
    Write_Point(xc-y,yc+x,colour); 
    Write_Point(xc-y,yc-x,colour); 
} 

/**************************************************************************** 
ƣWrite_yuan(int xc,int yc,int r,unsigned char colour) 
ܣԲ 
ڲxc  Բĵ 
           yc  Բĵ 
           r   뾶 
         color ʾɫ(ںڰɫLCMΪ0ʱΪ1ʱʾ) 
****************************************************************************/ 
void Write_yuan(uint xc,uint yc,uint r,uchar colour) 
{ 
    int x,y,d; 
    y=r; 
    d=3-2*r; 
    x=0; 
    while(x<=y) 
    { 
        plotC(x,y,xc,yc,colour); 
        if(d < 0) 
            d+=(4*x)+6; 
        else 
        { 
            d+=(4*(x-y))+10; 
            y=y-1; 
        } 
        x=x+1; 
    } 
} 


/********************ʵԲ*********************/
/**************************************************************************** 
ƣWrite_yuan2(uint x, uint y, uint r,uchar flag)
ܣûͼķһ 
ڲx Բĺ 
           y Բ 
           r 뾶
		   flag  ɫ־λΪ1.
****************************************************************************/ 

void Write_yuan2(uint x, uint y, uint r,uchar flag)
{
	uint dx,dy,ref;
	uint Temp;

	if(r==0)return;
	dx=r;
	dy=1;
	ref=707*r/1000;  // 0.707r
	while(dy<=dx)
	{
   		if(dx>ref)
	   	Write_Line(x+ref+1,y+dy,x+dx,y+dy,flag);

   		if(x>=ref+1&&dx>ref)
   		{
    		if(x<dx)
     			Temp=0;
    		else
     			Temp=x-dx;
    			Write_Line(Temp,y+dy,x-ref-1,y+dy,flag);
   		}
   
   		if(y>=dy&&dx>ref)
    	Write_Line(x+ref+1,y-dy,x+dx,y-dy,flag);

   		if(x>=ref+1&&y>=dy&&dx>ref)
   		{
    		if(x<dx)
     			Temp=0;
    		else
     			Temp=x-dx;
     			Write_Line(Temp,y-dy,x-ref-1,y-dy,flag);
   		}

   		if(dy!=dx||dx==ref)
   		{
    		if(y<dx)
     			Temp=0;
    		else
     			Temp=y-dx;
    			Write_Line(x+dy,Temp,x+dy,y+dx,flag);
   		}

   		if(x>=dy&&(dy!=dx||dy==ref))
   		{
    		if(y<dx)
     			Temp = 0;
    		else
     			Temp=y-dx;
    			Write_Line(x-dy,Temp,x-dy,y+dx,flag);
   		} 
   		dy++;

   		if((r*r-dy*dy)<=(dx-1)*dx)
   		dx--; 
	} 

	Write_Line(x+ref+1,y,x+r,y,flag);
	if(x>=ref+1)
	{
   		if(x<r)
    		Temp=0;
   		else
    		Temp=x-r;
    		Write_Line(Temp,y,x-ref-1,y,flag);
	

	if(y<r)
   		Temp=0;
	else
   		Temp=y-r;
   		Write_Line(x,Temp,x,y+r,flag); 
	}
}

 






/**************************************************************************** 
ƣWrite_Full(unsigned char x0,unsigned char y0,unsigned char x1,unsigned char y1,unsigned char colour) 
ܣûͼķһ 
ڲx0 ʼ 
           y0 ʼ 
           x1 ֹ 
           y1 ֹ 
          color ʾɫ(ںڰɫLCMΪ0ʱΪ1ʱʾ) 
****************************************************************************/ 
void Write_Full(uchar x0,uchar y0,uchar x1,uchar y1,uchar colour) 
{ 
    uchar i,j; 
	for(j=y0;j<=y1;j++) 
    for(i=x0;i<=x1;i++) 
    Write_Point(i,j,colour); 
}


/********************************************************
  ƣLCD_init
  ܣʼ12864Һ
*********************************************************/
void LCD_init(void)
{
   	Write_com(0x30);   //ָ
   	delayms(1);
   	Write_com(0x02);   //ַλ
   	delayms(1);
   	Write_com(0x0c);   //ʾ򿪣αر
   	delayms(1);
   	Write_com(0x01);   //ʾ
   	delayms(1);
   	Write_com(0x06);   //α
   	delayms(1);
   	Write_com(0x80);   //趨ʾʼַ
}



void main ()
{  	
	uchar i=0;
   	LCD_init();
   	Write_com(0x01);
   	Write_com(0x80);
   	for(i=0;i<16;i++)
   	{
     	Write_data(table[i]);
     	delayms(5);
   	}
   
  	clear_GDRAM();
  
  	Write_Line(20,1,62,125,1);
  	Write_Line(62,1,62,125,1);
  	Write_Line(20,1,62,1,1);

	Write_yuan(40,40,10,1);
	Write_yuan2(40,90,20,1); 

   	Write_Line(40,1,40,30,1);
	Write_Line(40,30,60,30,1);
	Write_Line(60,30,60,1,1);
	Write_Line(60,1,40,1,1);
	Write_Full(40,1,60,30,1);

   	while(1);
}



