//ֿ12864Һʾ
  //Ϊֿ12864Һʾ
//ʹPctolcdȡģΪ룬ʽ
#include <reg52.h>
#include<math.h>
#define uchar unsigned char
#define Disp_On 0x3f//ʾ
#define Disp_Off 0x3e//ʾ
#define Col_Add 0x40//еַ
#define Page_Add 0xb8//ҳַ
#define Start_Line 0xc0//ʼ

sbit cs1=P1^3;
sbit cs2=P1^4;
sbit Di=P1^0;
sbit RW=P1^1;
sbit EN=P1^2;
sbit RST=P1^5;

uchar GDRAM_hbit,GDRAM_lbit;

					
void delayms(int z)
{
int x,y;
for(x=z;x>0;x--)
  for(y=110;y>0;y--);
}

uchar Read_data(uchar cs)
//CS=1ΪCS=2Ϊ
{
uchar dat;
if(cs==1) 
{
cs1=1;cs2=0;
}
else
 {
  cs1=0;cs2=1;
 }

	P0=0xff;
	EN=0;
	Di=1; // D/I=1
	RW=1; // R/W=1.ȡ
	delayms(10);
	EN=1;
	delayms(100);
	dat=P0;    //ȡǰʾ
	EN=0;
	return(dat);  
}	

void write_com(uchar cs,uchar com)
//CS=1ΪCS=2Ϊ
{
if(cs==1) 
{
cs1=1;cs2=0;
}
else
 {
  cs1=0;cs2=1;
 }
Di=0;
RW=0;
P0=com;
delayms(1);
EN=1;
delayms(1);
EN=0;

}



void write_dat(uchar cs,uchar dat)
//CS=1ΪCS=2Ϊ
{
 if(cs==1)
 {
cs1=1;cs2=0;
}
else
{
 cs1=0,cs2=1;
}
Di=1;
RW=0;
P0=dat;
delayms(1);
EN=1;
delayms(1);
EN=0;
}

void clear(uchar cs)
//CS=1ΪCS=2Ϊ
{
  uchar j,k;
  if(cs==1)
  {
  cs1=1;cs2=0;
  }
  else
  {
    cs1=0;cs2=1;
  }
  write_com(cs,Page_Add+0);
  write_com(cs,Col_Add+0);
   for(k=0;k<8;k++)
     {
	  write_com(cs,Page_Add+k);
	    for(j=0;j<64;j++)
		write_dat(cs,0x00);
	 }
	
}

/*
void Draw_dots(unsigned char x,unsigned char y,unsigned char color)
{
    uchar cs;
    uchar x_byte;
    uchar x_bit;
    uchar Temp_data;//ʱŴLCD
    x_byte=(y>>3);          //õĸֽ
    x_bit=y-(x_byte<<3);    //ֽڵһλ
	cs=x/64; //Ұ,0 ,1 Ұ     
    
    write_com(cs+1,Start_Line+x_byte);        //еַ
    write_com(cs+1,Col_Add+x);           //еַ
     Temp_data=Read_LCD(cs+1);    //ȶûǰLCDе
    switch(color)
    {
        case 0 : Temp_data &= ~(1<<x_bit);break;    //
        case 1: Temp_data |= (1<<x_bit); break;    //
		case 2 : Temp_data ^= (1<<x_bit); break;    //        
        default : break;
    }
    
    write_com(cs+1,Start_Line+x_byte);
    write_com(cs+1,Col_Add+x);
    write_dat(cs+1,Temp_data);    //͵LCDʾ

}  /


/****************************
㺯:Write_Point()
xʾУyʾΪС
******************************/


void Write_Point(uchar x,uchar y,uchar flag)
{	uchar cs;
    uchar x_dyte,x_byte; //еַֽλֽе1λ 
	uchar y_dyte,y_byte; //Ϊ(ȡֵΪ01)еַ(ȡֵΪ0~31)
	cs=x/64;
  /***X,Y껥ͨX,Y***/

  	x_dyte=x/16; //16ֽеһ
  	x_byte=x&0x0f; //ڸֽеһλ
  	y_dyte=y/32; //0Ϊϰ1Ϊ°
  	y_byte=y&0x1f; //0~31еһ
  	write_com(cs+1,0x80+y_byte); //趨еַ(y)
  	write_com(cs+1,0x80+x_dyte); //趨еַ(x)ͨ8*y_Dyteѡ

    Read_data(cs+1);
	GDRAM_hbit=Read_data(cs+1);//ȡǰʾ8λ
	GDRAM_lbit=Read_data(cs+1);//ȡǰʾ8λ 
  	delayms(1);


  	if(flag==1)
	{ 
		write_com(cs+1,0x80+y_byte); //趨еַ(y)
  		write_com(cs+1,0x80+x_dyte); //趨еַ(x)ͨ8*y_Dyteѡ
		delayms(1);
  		
		if(x_byte<8) //жڸ8λڵ8λ
		{
			write_dat(cs+1,GDRAM_hbit|(0X01<<(7-x_byte)));   //ʾGDRAM8λ
			write_dat(cs+1,GDRAM_lbit); //ʾGDRAM8λ 
		}
    	else
		{
    		write_dat(cs+1,GDRAM_hbit);
			write_dat(cs+1,GDRAM_lbit|(0x01<<(15-x_byte)));
		}
    }
	else
	{
		write_dat(cs+1,0x00); //GDRAM8λ
		write_dat(cs+1,0x00); //GDRAM8λ
	}
}      


void Write_Line(uchar x0,uchar y0,uchar x1,uchar y1) 
{ 
    int temp; 
    int dx,dy; //㵽յĺᡢֵ 
    int s1,s2,i,j; 
    int Dx,Dy,k; 

    dx=x1-x0; 
    if(dx>=0) //Xķӵ 
    	s1=1; 
    else   //Xķǽ͵ 
        s1=-1; 
		     
    dy=y1-y0; //жYķӻǽ 
    if(dy>=0) 
        s2=1; 
    else 
        s2=-1; 
   
    Dx=abs(x1-x0); //ᡢݱ־ֵľֵ 
    Dy=abs(y1-y0); 
    if(Dy>Dx)                               
    { //45ȽΪֽߣYstatus=1,Xstatus=0  
        temp=Dx; 
        Dx=Dy; 
        Dy=temp; 
    	j=1; 
    }  
    else 
        j=0; 


/*********Bresenham㷨ֱ********/  
    k=2*Dy-Dx; //1ж¸λ 
    for(i=0;i<Dx;i++) 
    {  
       // write_point(x0,y0); //  
        if(k>=0)                                
        {  
            if(j==1) //ڿYxֵ1 
            x0+=s1;  
            else   //ڿXyֵ1                
            y0+=s2;  
           	k-=2*Dx; //ж¸λ  
        }  
        if(j==1) 
            y0+=s2;  
        else        
            x0+=s1;  
        	k+=2*Dy;  
    }  
} 
     

void init_lcd()
{
 RST=0;
 delayms(50);
 RST=1;
 delayms(50);
 write_com(1,Disp_Off);	 write_com(2,Disp_Off);
 write_com(1,Page_Add+0);write_com(2,Page_Add+0);
 write_com(1,Start_Line+0); write_com(2,Start_Line+0);
 write_com(1,Col_Add); write_com(2,Col_Add);
  write_com(1,Disp_On);	 write_com(2,Disp_On);
}

void main()
{
 init_lcd();
 clear(1);clear(2);
 Write_Point(127,7,1);
 Write_Point(127,6,1);
 Write_Point(127,5,1);
 Write_Point(127,4,1);
 Write_Point(127,3,1);
 Write_Point(127,2,1);
 Write_Point(127,1,1);
 Write_Point(127,0,1);
//Draw_dots(50,50,1);
  while(1);
 
 
}



