//ֿ12864Һʾ
#include<reg52.h>
#include<math.h>
#define uchar unsigned char
#define uint unsigned int
#define RSsp_On 0x3f//ʾ
#define RSsp_Off 0x3e//ʾ
#define Col_Add 0x40//еַ
#define Page_Add 0xb8//ҳַ
#define Start_Line 0xc0//ʼҳ	
sbit cs1=P1^3; //Master chip EN
sbit cs2=P1^4; //Slave chip EN
sbit en=P1^2; // mode EN single
sbit rs=P1^0; //Data or Instrument Select
sbit rw=P1^1; //Write or Read
sbit rst=P1^5; //Lcm reset
uchar  GDRAM_hbit=0;
uchar  GDRAM_lbit=0;

/***********************ʱӳ***********************/
void delayms(int k)
{
   int i,j;
for(i=k;i>0;i--)
for(j=10;j>0;j--);
}

/*************дָ************************/
void write_com(uchar com)
{
rs=0;
rw=0;
P0=com;
delayms(1);
en=1;
delayms(1);
en=0;
}

/*************д************************/
void write_dat(uchar dat)
{
rs=1;
rw=0;
P0=dat;
delayms(1);
en=1;
delayms(1);
en=0;
}


/**********************************/
void clear()
{
uchar j,k;
cs1=1;cs2=1;
write_com(Page_Add+0);
write_com(Col_Add+0);
  for(j=0;j<8;j++)
	{
	  write_com(Page_Add+j);
	   for(k=0;k<64;k++)
	    write_dat(0x00);
	}

}


/*********************************************************
  : Read_data
  ܣҺæж
   
ֵ01
*********************************************************/
uchar Read_data()
{
	uchar dat;
	P0=0xff;
	en=0;
	rs=1; // D/I=1
	rw=1; // R/W=1.ȡ
	delayms(10);
	en=1;
	delayms(100);
	dat=P0;    //ȡǰʾ
	en=0;
	return(dat);   
}

/****************************
㺯:Write_Point()
xʾУyʾΪС
******************************/


void Write_Point(uchar x,uchar y,uchar flag)
{
    uchar x_dyte,x_byte; //еַֽλֽе1λ 
	uchar y_dyte,y_byte; //Ϊ(ȡֵΪ01)еַ(ȡֵΪ0~31)
		write_com(0x34); 
	write_com(0x36); //ͼģʽ

  /***X,Y껥ͨX,Y***/

  	x_dyte=y/16; //16ֽеһ
  	x_byte=y&0x0f; //ڸֽеһλ
  	y_dyte=x/32; //0Ϊϰ1Ϊ°
  	y_byte=x&0x1f; //0~31еһ
  	write_com(0x80+y_byte); //趨еַ(y)
  	write_com(0x80+x_dyte+8*y_dyte); //趨еַ(x)ͨ8*y_Dyteѡ

    Read_data();
	GDRAM_hbit=Read_data();//ȡǰʾ8λ
	GDRAM_lbit=Read_data();//ȡǰʾ8λ 
  	delayms(1);


  	if(flag==1)
	{ 
		write_com(0x80+y_byte); //趨еַ(y)
  		write_com(0x80+x_dyte+8*y_dyte); //趨еַ(x)ͨ8*y_Dyteѡ
		delayms(1);
  		
		if(x_byte<8) //жڸ8λڵ8λ
		{
			write_dat(GDRAM_hbit|(0X01<<(7-x_byte)));   //ʾGDRAM8λ
			write_dat(GDRAM_lbit); //ʾGDRAM8λ 
		}
    	else
		{
    		write_dat(GDRAM_hbit);
			write_dat(GDRAM_lbit|(0x01<<(15-x_byte)));
		}
    }
	else
	{
		write_dat((0x00)); //GDRAM8λ
		write_dat((0x00)); //GDRAM8λ
	}
}      


/**************12864ָдһ****************/
void write_point(uchar x,uchar y)//x꣨0-127y꣨0-7datΪҪд

{
 uchar i,j=0x01; 
 cs1=0,cs2=0;
 if(x<64)
   cs1=1;
 else
 {
 cs2=1;
 x=x-64;
 }
 i=y/8;
 j=j<<(y%8);
 write_com(Col_Add+x);//趨ʼ,X
 write_com(Page_Add+i);//趨ʼ,Y
 write_dat(j);
}


 void Write_Line(uchar x0,uchar y0,uchar x1,uchar y1) 
{ 
    int temp; 
    int dx,dy; //㵽յĺᡢֵ 
    int s1,s2,i,j; 
    int Dx,Dy,k; 

    dx=x1-x0; 
    if(dx>=0) //Xķӵ 
    	s1=1; 
    else   //Xķǽ͵ 
        s1=-1; 
		     
    dy=y1-y0; //жYķӻǽ 
    if(dy>=0) 
        s2=1; 
    else 
        s2=-1; 
   
    Dx=abs(x1-x0); //ᡢݱ־ֵľֵ 
    Dy=abs(y1-y0); 
    if(Dy>Dx)                               
    { //45ȽΪֽߣYstatus=1,Xstatus=0  
        temp=Dx; 
        Dx=Dy; 
        Dy=temp; 
    	j=1; 
    }  
    else 
        j=0; 


/*********Bresenham㷨ֱ********/  
    k=2*Dy-Dx; //1ж¸λ 
    for(i=0;i<Dx;i++) 
    {  
write_point(x0,y0); //  
        if(k>=0)                                
        {  
            if(j==1) //ڿYxֵ1 
            x0+=s1;  
            else   //ڿXyֵ1                
            y0+=s2;  
           	k-=2*Dx; //ж¸λ  
        }  
        if(j==1) 
            y0+=s2;  
        else        
            x0+=s1;  
        	k+=2*Dy;  
    }  
} 


/***********ʼ****************************/
void init()
{
 rst=0;
 delayms(100);
 rst=1;
 delayms(100);
 cs1=1;
 cs2=1;
 delayms(100);
 write_com(RSsp_Off);
 write_com(Page_Add+0);
  write_com(Col_Add+0);
 write_com(Start_Line+0);
  write_com(RSsp_On);
}

/**************************************************************************** 
ƣplotC(int x,int y,int xc,int yc,unsigned char colour) 
ܣ˷ֵ㻭Բ 
ڲx ָеλ 
           y ָеλ 
          color ʾɫ(ںڰɫLCMΪ0ʱΪ1ʱʾ) 
****************************************************************************/ 
void plotC(uint x,uint y,uint xc,uint yc) 
{ 
    write_point(xc+x,yc+y); 
    write_point(xc+x,yc-y); 
    write_point(xc-x,yc+y); 
    write_point(xc-x,yc-y); 
    write_point(xc+y,yc+x); 
    write_point(xc+y,yc-x); 
    write_point(xc-y,yc+x); 
    write_point(xc-y,yc-x); 
} 

/**************************************************************************** 
ƣWrite_yuan(int xc,int yc,int r,unsigned char colour) 
ܣԲ 
ڲxc  Բĵ 
           yc  Բĵ 
           r   뾶 
         color ʾɫ(ںڰɫLCMΪ0ʱΪ1ʱʾ) 
****************************************************************************/ 
void Write_yuan(uint xc,uint yc,uint r) 
{ 
    int x,y,d; 
    y=r; 
    d=5/4-r; 
    x=0; 
    while(x<=y) 
    { 
        plotC(x,y,xc,yc); 
        if(d < 0) 
            d+=2*x+3; 
        else 
        { 
            d+=2*(x-y)+5; 
            y=y-1; 
        } 
        x=x+1; 
    } 
}

  
void Write_yuan2(uint x, uint y, uint r)
{
	uint dx,dy,ref;
	uint Temp;

	if(r==0)return;
	dx=r;
	dy=1;
	ref=707*r/1000;  // 0.707r
	while(dy<=dx)
	{
   		if(dx>ref)
	   	Write_Line(x+ref+1,y+dy,x+dx,y+dy);

   		if(x>=ref+1&&dx>ref)
   		{
    		if(x<dx)
     			Temp=0;
    		else
     			Temp=x-dx;
    			Write_Line(Temp,y+dy,x-ref-1,y+dy);
   		}
   
   		if(y>=dy&&dx>ref)
    	Write_Line(x+ref+1,y-dy,x+dx,y-dy);

   		if(x>=ref+1&&y>=dy&&dx>ref)
   		{
    		if(x<dx)
     			Temp=0;
    		else
     			Temp=x-dx;
     			Write_Line(Temp,y-dy,x-ref-1,y-dy);
   		}

   		if(dy!=dx||dx==ref)
   		{
    		if(y<dx)
     			Temp=0;
    		else
     			Temp=y-dx;
    			Write_Line(x+dy,Temp,x+dy,y+dx);
   		}

   		if(x>=dy&&(dy!=dx||dy==ref))
   		{
    		if(y<dx)
     			Temp = 0;
    		else
     			Temp=y-dx;
    			Write_Line(x-dy,Temp,x-dy,y+dx);
   		} 
   		dy++;

   		if((r*r-dy*dy)<=(dx-1)*dx)
   		dx--; 
	} 

	Write_Line(x+ref+1,y,x+r,y);
	if(x>=ref+1)
	{
   		if(x<r)
    		Temp=0;
   		else
    		Temp=x-r;
    		Write_Line(Temp,y,x-ref-1,y);
	

	if(y<r)
   		Temp=0;
	else
   		Temp=y-r;
   		Write_Line(x,Temp,x,y+r); 
	}
}

/**************************************************************************** 
ƣWrite_Full(unsigned char x0,unsigned char y0,unsigned char x1,unsigned char y1,unsigned char colour) 
ܣûͼķһ 
ڲx0 ʼ 
           y0 ʼ 
           x1 ֹ 
           y1 ֹ 
          color ʾɫ(ںڰɫLCMΪ0ʱΪ1ʱʾ) 
****************************************************************************/ 
void Write_Full(uchar x0,uchar y0,uchar x1,uchar y1) 
{ 
    uchar i,j; 
	for(j=y0;j<=y1;j++) 
    for(i=x0;i<=x1;i++) 
    write_point(i,j); 
}


void main()
{
	init();
	clear();
	write_point(5,5);
		write_point(10,10);
	Write_Line(20,20,50,20);
	Write_Line(20,20,20,60);
//		Write_Full(40,1,60,30);
 //
 //Write_Line(40,1,40,30);
//	Write_Line(40,30,60,30);
//	Write_Line(60,30,60,1);
//	Write_Line(60,1,40,1);
	while(1);
}






